"""
Adapted from the cherrypy Tutorial: File upload and download

Copy"stuff": Kerim Mansour @ codeboje.de
"""

import os
import imageresizer as ir
import StringIO
import cherrypy

class ImageResize(object):
    
    def index(self):
        return """
        <html><body>
            <form action="upload" method="post" enctype="multipart/form-data">
            Select the picture to resize (max size = 3 MB): <input type="file" name="myFile" /><br />
            Keep Aspect Ratio ? <input type="checkbox" name="aspect" value="aspect" checked/><br />
            Define new width/height. <br/>
            If aspect ratio is to be preserved the smaller number of width and height is used to calculate the image size.<br/>
          
            New width (0 if not important) <input type="text" name="width" value="0"/><br />
            New height (0 if not important) <input type="text" name="height" value="0"/><br />
            <input type="submit" />
            </form>
        </body></html>
        """
    index.exposed = True
    
    def upload(self, myFile, width, height,aspect='no'):
        errorout = """<html>
        <body>
             %s<br />
        </body>
        </html>"""
        
        #determine type and skip all things that are not pictures
        types=['jpg','jpeg','gif','png']
        type=myFile.filename[myFile.filename.find('.')+1:].lower()
        if type not in types:
          return errorout % type
        if  type=='jpg':
          type='jpeg'
        
        #read data, see if the file is too big and do some other checks 
        size = 0
        data = myFile.file.read()
        if not data:
          return errorout % ('No File uploaded')
        size += len(data)
        if size >3000000:
          return errorout % ('File too big (>3MB)')
        imageio = StringIO.StringIO(data)
        try:
          width=int(width)
          height=int(height)
          if width==0 and height ==0:
            return errorout % ('Width, Height are BOTH not given')
          if (width==0 or height==0) and aspect=='no':
            return errorout % ('Width, Height must both be set for resize without keeping aspect ratio')
        except:
          return errorout % ('Width, Height not numbers')
        
        #resize
        newimage=ir.createImageFromString(imageio,(width,height), aspect=='aspect')
        response = cherrypy.response
        response.headers['Content-Type'] = 'image/'+type
        return newimage.tostring(type,'RGB')
        
    upload.exposed = True


def main():
    app = cherrypy.tree.mount(ImageResize())
    cherrypy.quickstart(app)
   

if __name__ == "__main__":
    main()
