#!/usr/bin/python
from PIL import Image
import StringIO

''' resizes an image keeping the aspect ratio. 
A value of 0 means that the new size in that direction is unimportant and can be ignored
'''
def aspectResize(image,newsize,resample):
  x, y = image.size  
  #resize the first that is smaller than the target first
  #then shrink again to make the second dimension fit
  if x < newsize[0] and newsize[0]!=0: 
    y = max(y * newsize[0] / x, 1)
    x = newsize[0]
    if y > newsize[1]and newsize[1]!=0:  
      x = max(x * newsize[1] / y, 1)
      y = newsize[1]
  elif y < newsize[1] and newsize[1]!=0: 
    x = max(x * newsize[1] / y, 1)
    y = newsize[1]
    if x > newsize[0]and newsize[0]!=0: 
      y = max(y * newsize[0] / x, 1)
      x = newsize[0]
  
  size = x, y

  if size == image.size:
    return image
  
  try:
    im = image.resize(size, resample)
  except ValueError:
    if resample != ANTIALIAS:
      raise
    im = image.resize(size, NEAREST)
  return im


def createImageFromString(file,newsize,aspectRatio=True):
  image = Image.open(file) 
  oldsize=image.size
  if aspectRatio==True:
    if oldsize[0]>newsize[0] and oldsize[1]>newsize[1]:
      #we need to get rid of 0 as minimum value or thumbnails will give us nothing
      #hardcoded 5000 is a bit stupid but works
      x,y=newsize
      if x==0:
        x=max(5000,x)
      if y==0:
        y=max(5000,y)
      newsize=(x,y)
      image.thumbnail(newsize,Image.ANTIALIAS)
    else:
      image=aspectResize(image,newsize,Image.ANTIALIAS)
  else:
    image=image.resize(newsize,Image.ANTIALIAS)
  return image

# just for testing
if __name__ == '__main__':
  file = open('test.jpg','rb')
  fileString = StringIO.StringIO(file.read())
  newimage=createImageFromString(fileString,(400,1600))
  newimage.save('c:/test2.jpg')
  
